clear
t=[0,1000];
xinit=[0 1 0];  % Random initial point

%Solving system using ODE45
[t,x]=ode45(@(t,x) ODESys(x), t, xinit);

%%% Rotating flow to pick out desired Poincare section %%%
q = pi/2.5;
xtrans = [1 0 0; 0 cos(q) -sin(q); 0 sin(q) cos(q)];    
ytrans = [cos(q)  0 sin(q); 0 1 0; -sin(q) 0 cos(q)];
ztrans = [cos(q) -sin(q) 0 ; sin(q) cos(q) 0; 0 0 1];
newdata = x * ztrans;
newerdata = [t, newdata];

save 'myfile.dat' newerdata -ascii; % Saves flow in myfile.dat

plot3(newdata(:,1),newdata(:,2),newdata(:,3),'LineWidth',1);
alw = 0.75;    % AxesLineWidth
fsz = 14;      % Fontsize
xlabel('$$\hat{x}$$','Interpreter','Latex','fontsize',14)
ylabel('$$\hat{y}$$','Interpreter','Latex','fontsize',14)
zlabel('$$\hat{z}$$','Interpreter','Latex','fontsize',14)