D=load('myfile.dat');   % The flow is saved in myfile.dat

var=4;          % Chooses the rotated coordinate axis for Poincare section
cut=5;          % Chooses the Poincare section in rotated space; e.g.
                %   cut = 5 => the Poincare section is located at
                %   r = 5, and theta = 2pi/5 D)

%%% Picks out other two variables %%%               
for i = 2:4
    if i ~= var
varo1=i;       
i = i+1;
if i ~= var
    varo2 = i;
else
    varo2 = i+1;
end
break;
    end
end

x=D(:,var);     % Extract time series for variable var

xt=x(2:end-1);  % Value of discretized flow on var axis
xp=x(1:end-2);  % Previous time value
xm=x(3:end);    % Next time value

%%% Finds which pairs of points are closest to the Poincare section %%%
k=find(((xp<cut) & (xt>=cut)) | ((xp>cut) & (xm<=cut)));

%%% Finds points on the flow intersecting with the Poincare section %%%
 R=zeros(size(D));
for i=1:length(k)
    R(i,:)=D(k(i),:);
end

plot(R(:,varo1),R(:,varo2),'b.')
% hold on
% plot([A(:,1); A(1,1)],[A(:,2); A(1,2)],'r.','MarkerSize',1)
% hold off
xlabel('$$\hat{x}$$','Interpreter','Latex','fontsize',14)
ylabel('$$\hat{y}$$','Interpreter','Latex','fontsize',14)
% title(sprintf('Trapping Region'))
title('Horseshoe-like structure')
alw = 0.75;    % AxesLineWidth
fsz = 14;      % Fontsize