function firstRet = PoincareMap(xinit) % xinit calls a particular 
                                       %    ordered triplet
t=[0,1000];
axis = 4;  % Chooses the rotated coordinate axis for Poincare section
cutter = 5;  % Chooses the Poincare section in rotated space; e.g.
                %   cut = 5 => the Poincare section is located at
                %   r = 5, and theta = 2pi/5

%%% Solving system using ODE45 %%%
q = -pi/2.5;  % Counter rotation to pick out the proper initial conditions
              % in "ODESys"
ztrans = [cos(q) -sin(q) 0 ; sin(q) cos(q) 0; 0 0 1];
xinit = xinit * ztrans;
[t,x]=ode45(@(t,x) ODESys(x), t, xinit);

%%% Rotating flow to pick out desired Poincare section %%%
q = pi/2.5; % theta = 2pi/5
ztrans = [cos(q) -sin(q) 0 ; sin(q) cos(q) 0; 0 0 1];
newdata = x * ztrans;
newerdata = [t, newdata];


x= newerdata(: , axis);     % Extract time series for variable var
xt=x(2:end-1);  % Value of discretized flow on var axis
xp=x(1:end-2);  % Previous time value
xm=x(3:end);    % Next time value
m = length(xt);


for i = 1:m
    if((xp(i, 1)<cutter) && (xt(i, 1)>=cutter)) || ((xp(i, 1)>cutter)...
            && (xm(i, 1)<=cutter))
            firstRet = newerdata(i, :);
            break
    end
end