D=load('myfile.dat');   % The flow is saved in myfile.dat

%%%  Vertices of quadrilateral %%%
% A = [-3.6 -27 5; 11.91 -6.5 5; 12 0 5; -8 3 5];  % This one works
A = [-3.55 -27 5; 11.91 -6.6 5; 12 0 5; -8.5 3.5 5];  % A better one

%%%  Points between the vertices on the quadrilateral %%%
x1 = [A(1,1):(A(2,1)-A(1,1))/1000:A(2,1)]';
y1 = (A(1,2)-A(2,2))/(A(1,1)-A(2,1))*(x1 - A(1,1)) + A(1,2);
z1 = ones(size(x1))*5;
x2 = [A(2,1):(A(3,1)-A(2,1))/1000:A(3,1)]';
y2 = (A(2,2)-A(3,2))/(A(2,1)-A(3,1))*(x2 - A(2,1)) + A(2,2);
z2 = ones(size(x2))*5;
x3 = [A(3,1):(A(4,1)-A(3,1))/1000:A(4,1)]';
y3 = (A(3,2)-A(4,2))/(A(3,1)-A(4,1))*(x3 - A(3,1)) + A(3,2);
z3 = ones(size(x3))*5;
x4 = [A(4,1):(A(1,1)-A(4,1))/1000:A(1,1)]';
y4 = (A(4,2)-A(1,2))/(A(4,1)-A(1,1))*(x4 - A(4,1)) + A(4,2);
z4 = ones(size(x4))*5;

A = [x1 y1 z1; x2 y2 z2; x3 y3 z3; x4 y4 z4];

var=4;          % Chooses the rotated coordinate axis for Poincare section
cut=5;          % Chooses the Poincare section in rotated space; e.g.
                %   cut = 5 => the Poincare section is located at
                %   r = 5, and theta = 2pi/5

%%% Picks out other two variables %%%
for i = 2:4
    if i ~= var
varo1=i;        
i = i+1;
if i ~= var
    varo2 = i;
else
    varo2 = i+1;
end
break;
    end
end

x=D(:,var);     % Extract time series for variable var

xt=x(2:end-1);  % Value of discretized flow on var axis
xp=x(1:end-2);  % Previous time value
xm=x(3:end);    % Next time value

%%% Finds which pairs of points are closest to the Poincare section %%%
k=find(((xp<cut) & (xt>=cut)) | ((xp>cut) & (xm<=cut)));


%%% Computes iterates of A %%%

Q = zeros(length(A),4);
parfor i = 1:length(A)
    Q(i,:) = PoincareMap(A(i, :));
end

%%% Manually add in number of higher order %%%
%%%     returns in order to use parfor %%%

%%% Second Returns %%%
Q1 = zeros(size(Q));
Q_spare = Q(:,2:4);
parfor i = 1:length(Q)
    Q1(i,:) = PoincareMap(Q_spare(i, :));
end

%%% Third Returns %%%
Q2 = zeros(size(Q1));
Q_spare = Q1(:,2:4);
parfor i = 1:length(Q1)
    Q2(i,:) = PoincareMap(Q_spare(i, :));
end

%%% Fourth Returns %%%
Q3 = zeros(size(Q2));
Q_spare = Q2(:,2:4);
parfor i = 1:length(Q)
    Q3(i,:) = PoincareMap(Q_spare(i, :));
end

plot(Q(:,varo1),Q(:,varo2),'b.',Q1(:,varo1),Q1(:,varo2),'b.',...
    Q2(:,varo1),Q2(:,varo2),'b.',Q3(:,varo1),Q3(:,varo2),'b.');
hold on
plot([A(:,1); A(1,1)],[A(:,2); A(1,2)],'r.','MarkerSize',1)
hold off
xlabel('$$\hat{x}$$','Interpreter','Latex','fontsize',14)
ylabel('$$\hat{y}$$','Interpreter','Latex','fontsize',14)
title(sprintf('Trapping Region'))
alw = 0.75;    % AxesLineWidth
fsz = 14;      % Fontsize